Description:
Given an array of integers, return indices of the two numbers such that they add up to a specific target.
You may assume that each input would have exactly one solution, and you may not use the same element twice.
Example:
Given nums = [2, 7, 11, 15], target = 9,
Because nums[0] + nums[1] = 2 + 7 = 9,
return [0, 1].
Discuss:
1.暴力法:
时间复杂度: O(n^2)
空间复杂度: O(1)
class Solution {
public int[] twoSum(int[] nums, int target) {
int res[] = {0,0};
for (int i = 0;i<nums.length;++i){
for (int j = i+1;j<nums.length;++j){
if (target == (nums[i] + nums[j])){
res[0] = i;
res[1] = j;
}
}
}
return res;
}
}
class Solution {
public int[] twoSum(int[] nums, int target) {
for (int i = 0;i<nums.length;++i){
for (int j = i+1;j<nums.length;++j){
if (target == (nums[i] + nums[j]))
return new int[]{i,j};
}
}
return null;
}
}
2.Hash表
时间复杂度: O(n)
空间复杂度: O(n)
思路:利用哈希表将数组中的值依次存入,并且在数组遍历过程中找到另一个值
class Solution {
public int[] twoSum(int[] nums, int target) {
Map<Integer, Integer map = new HashMap< ();
for (int i = 0; i < nums.length; i++){
if(map.containsKey(target - nums[i])){
int[] r = new int[]{map.get(target - nums[i]), i} ;
return r;
}else{
map.put(nums[i], i);
}
}
return null;
}
}
I'm so cute. Please give me money.
- 本文链接:https://github.com/wentianhao/leetcode/blob/master/src/leetcode/TwoSum_1.java
- 版权声明:本博客所有文章除特别声明外,均默认采用 许可协议。
若没有本文 Issue,您可以使用 Comment 模版新建。